<?php
/*

() Club Veselchak U (club@shelek.com)
  , 
        .

****************************************

     readme.txt .

****************************************

 :

1.0	2006.02.25 RXL (rxl@mail.ru)
      .

1.0.1	2006.02.25 RXL (rxl@mail.ru)
     - check_yes.

1.0.2	2006.03.02 RXL (rxl@mail.ru)
       . -   .

1.0.3	2006.03.04 RXL (rxl@mail.ru)
    - save_to_file.

1.0.4	2006.03.05 RXL (rxl@mail.ru)
     .  .      '-'.

*/

class core__config
{
    var $_config;

    function core__config($tree = false)
    {
	if (!is_array($tree))
	    $tree = array();
	$this->_config = &$tree;
    }

    function _key_to_index($key)
    {
	$path = '';
	foreach (split('\.', $key) as $idx)
	    $path .= strlen($idx) ? "['$idx']" : "[]";
	return $path;
    }

    function get($key)
    {
	$path = "\$this->_config" . $this->_key_to_index($key);
	eval("\$value = isset($path) ? $path : false;");
	return $value;
    }

    function set($key, $value)
    {
	$path = "\$this->_config" . $this->_key_to_index($key);
	eval("$path = \$value;");
    }

    function check_yes($key) // : y, yes, on, true, >0 .    .
    {
	$value = $this->get($key);
	if (is_integer($value) && $value > 0)
	    return true;
	if (is_string($value) && preg_match('/^\s*(y|yes|on|true)\s*$/', strtolower($value)))
	    return true;
	return false;
    }

    function parse_text($text)
    {
	$strings = split("(\r\n|\n|\r)", $text);
	$a = array();
	while (count($strings))
	{
	    $string = array_shift($strings);
	    if (!preg_match('/^\s*([-\w]*(?:\.[-\w]*)*)\s*=\s*(.*)$/', $string, $a))
		continue;
	    $key = $a[1];
	    $value = $a[2];
	    while (preg_match('/(\\\\+)$/', $value, $a) && strlen($a[1])%2)
	    {
	    //    -  "\" -   .   
		if(!($string = array_shift($strings)))
		    break;
		$value = substr($value, 0, strlen($value) - 1) . $string;
	    }
	    $value = preg_replace('/\\\\n/', "\n", $value); // \n - LF
	    $value = preg_replace('/\\\\t/', "\t", $value); // \t - tab
	    $value = preg_replace('/\\\\\\\\/', "\\", $value); // \\ - \

	    $this->set($key, $value);
	}
    }

    function to_string($prefix = '', $node = '')
    {
	if ($node == '')
	    $node = $prefix ? $this->get($prefix) : $this->_config;
	if (!is_array($node))
	{
	    $text = $node;
	    $text = preg_replace('/\\\\/', '\\\\\\\\', $text);
	    $text = preg_replace('/\\n/m', '\\n', $text);
	    $text = preg_replace('/\\t/m', '\\t', $text);
	    $text = "$prefix = $text\n";
	}
	else
	{
	    $prefix .= $prefix ? '.' : '';
	    $text = '';
	    foreach ($node as $key=>$value)
	    {
		$text .= $this->to_string("$prefix$key", $value);
	    }
	}
	return $text;
    }

    function save_to_file($key, $file, $absolute = true) // 
    {
	if (!$absolute)
	    $file = $this->get('enfine.config_dir') . $file;
	$text = $this->to_string($key);
	$fd = @fopen($file, 'w+');
	if (!$fd)
	    return false;
	fwrite($fd, "<?php\n{\nreturn \"\n");
	fwrite($fd, $text);
	fwrite($fd, "\n\";\n}\n?>");
	fclose($fd);
	return true;
    }

    function proc_file($file, $absolute = true)
    {
	if (!$absolute)
	    $file = $this->get('engine.config_dir') . $file;
	if (!is_file($file))
	    return false;
	$this->parse_text(include_once($file));
	return true;
    }

    function proc_dir($path) // !!!   ,      -...
    {
	$default = '__default__.php';
	$custom = '__custom__.php';
	if (is_file($path . $default))
	    $this->proc_file($path . $default); //  - __default__.php

	$confdir = opendir($path);
	while ($file = readdir($confdir))
	{
	    if (is_file($path . $file) && substr($file, -4) == '.php' &&
		$file != $default && $file != $custom)
		$this->proc_file($path . $file);
	}
	closedir($confdir);

	if (is_file($path . $custom))
	    $this->proc_file($path . $custom); //   - __custom__.php
    }
}

?>