<?php

/*

() Club Veselchak U (club@shelek.com)
  , 
        .

****************************************

     readme.txt .

****************************************

 :

1.0	2006.03.04 RXL (rxl@mail.ru)
      . -: get_module, load_module.

1.0.1	2006.03.05 RXL (rxl@mail.ru)
    : engine.die_level  report,  macro.php
 .  .

1.0.2	2006.03.08 RXL (rxl@mail.ru)
      .   report  - _report.
    user_error. 
      
    .

*/

class core__core
{
    // modules
    var $_modules = array();
    // output processing
    var $_headers = array();
    var $_filters = array();
    var $_runlist = array();
    // error handling
    var $_report_mask;
    var $_die_mask;
    var $_show_vars_mask;
    var $_show_backtrace_mask;
    //
    var $stop_processing = false; // *** ffe

// 

    function core__core()
    {
	//    ,     
	switch ( _g('engine.debug.level'))
	{
	case 3: // full debugging mode
	    $this->_die_mask = E_ERROR | E_WARNING | E_PARSE | E_CORE_ERROR | E_CORE_WARNING |
		E_COMPILE_ERROR | E_COMPILE_WARNING | E_USER_ERROR | E_USER_WARNING;
	    $this->_report_mask = E_ERROR | E_WARNING | E_PARSE | E_NOTICE | E_CORE_ERROR |
		E_CORE_WARNING | E_COMPILE_ERROR | E_COMPILE_WARNING | E_USER_ERROR |
		E_USER_WARNING | E_USER_NOTICE;
	    error_reporting(E_ALL);
	    ini_set('display_errors', 1);
	    break;
	case 2: // debugging mode
	    $this->_die_mask = E_ERROR | E_WARNING | E_PARSE | E_CORE_ERROR | E_CORE_WARNING |
		E_COMPILE_ERROR | E_COMPILE_WARNING | E_USER_ERROR | E_USER_WARNING;
	    $this->_report_mask = E_ERROR | E_WARNING | E_PARSE | E_NOTICE | E_CORE_ERROR |
		E_CORE_WARNING | E_COMPILE_ERROR | E_COMPILE_WARNING | E_USER_ERROR |
		E_USER_WARNING;
	    error_reporting(E_ALL);
	    ini_set('display_errors', 1);
	    break;
	case 1: // testing mode
	    $this->_die_mask = E_ERROR | E_PARSE | E_CORE_ERROR | E_COMPILE_ERROR | E_USER_ERROR;
	    $this->_report_mask = E_ERROR | E_WARNING | E_PARSE | E_NOTICE | E_CORE_ERROR |
		E_CORE_WARNING | E_COMPILE_ERROR | E_COMPILE_WARNING | E_USER_ERROR |
		E_USER_WARNING;
	    error_reporting(E_ALL & ~(E_NOTICE | E_USER_NOTICE));
	    ini_set('display_errors', 1);
	    break;
	default: // working mode
	    $this->_die_mask = E_ERROR | E_PARSE | E_CORE_ERROR | E_COMPILE_ERROR | E_USER_ERROR;
	    $this->_report_mask = 0;
	    error_reporting(0);
	    ini_set('display_errors', 0);
	}

	switch ( _g('engine.debug.show_vars_level'))
	{
	case 2:
	    $this->_show_vars_mask = E_ERROR | E_WARNING | E_PARSE | E_CORE_ERROR | E_CORE_WARNING |
		E_COMPILE_ERROR | E_COMPILE_WARNING | E_USER_ERROR | E_USER_WARNING;
	    break;
	case 1:
	    $this->_show_vars_mask = E_ERROR | E_PARSE | E_CORE_ERROR | E_COMPILE_ERROR | E_USER_ERROR;
	    break;
	default:
	    $this->_show_vars_mask = 0;
	}

	switch ( _g('engine.debug.show_backtrace_level'))
	{
	case 2:
	    $this->_show_backtrace_mask = E_ERROR | E_WARNING | E_PARSE | E_CORE_ERROR | E_CORE_WARNING |
		E_COMPILE_ERROR | E_COMPILE_WARNING | E_USER_ERROR | E_USER_WARNING;
	    break;
	case 1:
	    $this->_show_backtrace_mask = E_ERROR | E_PARSE | E_CORE_ERROR | E_COMPILE_ERROR | E_USER_ERROR;
	    break;
	default:
	    $this->_show_backtrace_mask = 0;
	}

	set_error_handler(array(&$this, '_error_handler'));

	//   
	ignore_user_abort(true);
	register_shutdown_function(array(&$this, '_finalize'));
    }

//      

    function &get_module($module)
    {
	user_error("getting reference on '$module'", DEBUG);

	if (isset($this->_modules[$module]))
	    return $this->_modules[$module];

	if ( _yes('engine.core_auto_load'))
	{
	    if ($this->load_module($module))
		return $this->_modules[$module];
	}

	return false;
    }

    function load_module($module)
    {
	global $config;

	user_error("loading module '$module'", DEBUG);

	//   .
	if (isset($this->_modules[$module]))
	    return true;

	//     .
	$dir = _g('engine.root') . 'core/' . $module;
	if (!is_dir($dir))
	    return false;

	//      config.php  class.php .
	$class = $dir . '/class.php';
	if (!is_file($class))
	    return false;

	$conf = $dir . '/config.php';
	if (is_file($conf))
	    $config->proc_file($conf);

	include_once($class);

	$class = _g('engine.core_class_prefix') . $module;

	if (class_exists($class))
	{
	    //      .
	    $obj = new $class;
	    if (is_object($obj))
	    {
		$this->_modules[$module] = &$obj;

		$macro = $dir . '/macro.php';
		if (is_file($macro))
		    include_once($macro);

		return true;
	    }
	}

	return false;
    }

    function register_filter_function($cb)
    {
	if (is_callable($cb))
	    array_push($this->_filters, $cb);
	else
	    user_error("wrong argument", WARN);
    }

    function register_run_function($cb)
    {
	if (is_callable($cb))
	    array_push($this->_runlist, $cb);
	else
	    user_error("wrong argument", WARN);
    }

    function run()
    {
	//  
	ob_start();

	//   :     .  .
	$this->add_header(array('X-Powered-By: vu-core-' . _g('engine.version.full'), false));

	//      .
	foreach (array_keys($this->_modules) as $module)
	{
	    $obj = &$this->_modules[$module];
	    if (is_callable(array(&$obj, 'init')))
		call_user_func(array(&$obj, 'init'));
	}

	//   :  engine.run_list_start,   ,
	//  engine.run_list_final.
	// engine.run_list_* -    .   run.
	// $this->_runlist -  -.
	$runlist = array();

	if (($list = _g('engine.run_list_begin')) && is_array($list))
	    foreach($list  as $module)
	    {
		if (isset($this->_modules[$module]))
		    array_push($runlist, array(&$this->_modules[$module], 'run'));
		else
		    user_error("no module '$module'", WARN);
	    }

	$runlist = array_merge($runlist, $this->_runlist);

	if (($list = _g('engine.run_list_end')) && is_array($list))
	    foreach($list  as $module)
	    {
		if (isset($this->_modules[$module]))
		    array_push($runlist, array(&$this->_modules[$module], 'run'));
		else
		    user_error("no module '$module'", WARN);
	    }

	foreach ($runlist as $func)
	{
	    if (is_callable($func))
		call_user_func($func);
	    else
		user_error("error in runlist", WARN);
	}

	//      .
	foreach (array_reverse(array_keys($this->_modules)) as $module)
	{
	    $obj = &$this->_modules[$module];
	    if (is_callable(array(&$obj, 'init')))
		call_user_func(array(&$obj, 'final'));
	}

	//    ,     .
	if (count($this->_filters) == 0)
	{
	    $this->send_headers();
	    ob_flush();
	    return;
	}

	//       .
	$output_buffer = ob_get_contents();
	ob_clean();

	foreach ($this->_filters as $func)
	{
	    if (is_callable($func))
		$output_buffer = call_user_func($func, $output_buffer);
	    else
		user_error("error in filters", WARN);
	}

	//    .
	$this->send_headers();

	$debug_output = ob_get_clean();
	if ( _g('engine.debug.level') == 2)
	{
	    $output_buffer .= $debug_output;
	}

	echo $output_buffer;
    }

// -   

    function add_header($header)
    {
	array_push($this->_headers, $header);
    }

    function clear_headers($header)
    {
	$this->_headers = array();
    }

    function send_headers()
    {
	if (headers_sent($file, $line)) //    - -    .
	{
	    user_error("Header is already sent at $file:$line", WARN);
	    return;
	}

	foreach ($this->_headers as $header)
	{
	    if (!is_array($header) || count($header) == 0)
	    {
		user_error("Error in headers", WARN);
		continue;
	    }

	    user_error("Sent '$header[0]'", DEBUG);

	    switch (count($header))
	    {
	    case 1:
		header($header[0]);
		break;
	    case 2:
		header($header[0], $header[1]);
		break;
	    default:
		header($header[0], $header[1], $header[2]);
	    }
	}
    }

//  

    function _finalize()
    {
    }

    function _error_handler($errno, $errmsg, $filename, $linenumber, $vars)
    {
	$error_names = array(
	    E_ERROR => 'ERROR',
	    E_WARNING => 'WARNING',
	    E_PARSE => 'PARSE',
	    E_NOTICE => 'NOTICE',
	    E_CORE_ERROR => 'CORE_ERROR',
	    E_CORE_WARNING => 'CORE_WARNING',
	    E_COMPILE_ERROR => 'COMPILE_ERROR',
	    E_COMPILE_WARNING => 'COMPILE_WARNING',
	    E_USER_ERROR => 'USER_ERROR',
	    E_USER_WARNING => 'USER_WARNING',
	    E_USER_NOTICE => 'USER_NOTICE');

	if ($errno & $this->_report_mask)
	{
	    $error = isset($error_names[$errno]) ? $error_names[$errno] : "UNKNOWN_$errno";
	    echo "<div class='engine_error_block'><b>$error</b>: $filename:$linenumber<br />" .
		"<b><u>Text</u></b>: $errmsg";
	    if ($errno & $this->_show_backtrace_mask)
	    {
		echo "<br /><b><u>Backtrace</u></b>:<br />";
		$bt = debug_backtrace();
		array_shift($bt);
		foreach ($bt as $n=>$a)
		{
		    echo "#$n: " .
			($a['class'] ? "$a[class]" : '') .
			$a['type'] .
			($a['function'] ? "$a[function]()" : '') .
			" at $a[file]:$a[line]<br />";
		}
	    }
	    if ($errno & $this->_show_vars_mask)
		echo "<br /><b><u>Variables</u></b>:<pre>" . print_r($vars, true) . "</pre>";
	    echo "</div>";
	}

	if ($errno & $this->_die_mask)
	{
	    while (ob_get_level()) // ?
		ob_end_flush();
	    exit();
	}
    }
}

?>