<?php
/*

() Club Veselchak U (club@shelek.com)
  , 
        .

****************************************

     readme.txt .

****************************************

 :

1.0	2006.03.08 RXL (rxl@mail.ru)
      .

*/

class core__url
{
    //   URL.
    var $schema = 'http';
    var $user = '';
    var $pass = '';
    var $host = '';
    var $port = '';
    var $path = '';
    var $query = '';
    var $fragment = '';
    //  ,   ..
    var $path_parts = array();
    var $query_parts = array();
    //  .
    var $use_redirect = false;
    var $redirect_status = '';
    var $redirect_method = '';
    //   .
    var $request_method = '';

    function core__url($url = false, $delimiter = '')
    {
	if ($url === false)
	{
	    $this->host = $_SERVER['SERVER_NAME'];
	    $this->port = $_SERVER['SERVER_PORT'] == 80 ? '' : $_SERVER['SERVER_PORT'];
	    $this->request_method = $_SERVER['REQUEST_METHOD'];

	    if (isset($_SERVER['REDIRECT_STATUS']))
	    {
		// 
		$this->path = $_SERVER['REDIRECT_URL'];
		$this->query_parts = $this->split_path($_SERVER['REDIRECT_URL']);
		$this->query = $_SERVER['REDIRECT_QUERY_STRING'];
		$this->path_parts = $this->split_query($_SERVER['REDIRECT_QUERY_STRING'],
		    _g('engine.url.alt_query_delimiter'));
		$this->use_redirect = true;
		$this->redirect_status = $_SERVER['REDIRECT_STATUS']; // *
		$this->redirect_method = $_SERVER['REDIRECT_REQUEST_METHOD']; // *
	    }
	    else
	    {
		//  
		$this->path = $_SERVER['PHP_SELF'];
		$this->path_parts = $this->split_path($_SERVER['PHP_SELF']);
		$this->query = $_SERVER['QUERY_STRING'];
		$this->query_parts = $this->split_query($_SERVER['QUERY_STRING']);
	    }
	}
	else
	{
	    $delimiter = $delimiter ? $delimiter : _g('engine.url.query_delimiter');
	    //    .
	    $url_parts = parse_url($url);
	    if (isset($url_parts['scheme']))
		$this->scheme = $url_parts['scheme'];
	    if (isset($url_parts['user']))
		$this->user = $url_parts['user'];
	    if (isset($url_parts['pass']))
		$this->pass = $url_parts['pass'];
	    if (isset($url_parts['host']))
		$this->host = $url_parts['host'];
	    if (isset($url_parts['port']))
		$this->port = $url_parts['port'];
	    if (isset($url_parts['path']))
		$this->path = $url_parts['path'];
	    if (isset($url_parts['query']))
		$this->query = $url_parts['query'];
	    if (isset($url_parts['fragment']))
		$this->fragment = $url_parts['fragment'];
	    $this->path_parts = $this->split_path($url_parts['path']);
	    $this->query_parts = $this->split_query($url_parts['path']);
	}
    }


    function split_path($path)
    {
	if (substr($path,0,1) == '/')
	    preg_match_all('%/([^/?]+)%', $path, $parts);
	else
	    preg_match_all('%([^/?]+)%', $path, $parts);

	return $parts[1];
    }

    function split_filename($filename)
    {
	$filename = preg_replace('/[\x00-\x20"#<>]/', '', $filename); //   
	$parts = split('\.', $filename);
	if (count($parts) > 1)
	    $ext = array_pop($parts);
	else
	    $ext = '';
	return array (urldecode(join('.', $parts)), urldecode($ext));
    }

    function split_query($query, $delim = '')
    {
	if ($delim == '')
	    $delim = _g('engine.url.query_delimiter');

	$delim = '/[' . preg_quote($delim, '/') . ']/';
	$parts = preg_split($delim, $query);

	$args = array();
	foreach ($parts as $arg)
	{
	    $a = split('=', $arg, 2); //    name=value
	    if (count($a) == 1) $a[1] = '';
	    list($name, $value) = $a;
	    $name = $this->decode_url_string($name);
	    $value = $this->decode_url_string($value);
	    $args[$name] = $value;
	}
	return $args;
    }

    function decode_url_string($str)
    {
	$str = preg_replace('/%([^0-9A-Fa-f])/', '$1', $str);
	$str = preg_replace('/%([0-9A-Fa-f][^0-9A-Fa-f])/', '$1', $str);
	if (substr($str, -1, 1) == '%')
	    $str = substr($str, 0, strlen($str) - 1);
	$str = preg_replace('/[\x00-\x20\x22#<>]/', '', $str);
	$str = urldecode($str);
	$str = preg_replace('/[\x00-\x09\x0b\x0c\x0e-\x1f]/', '', $str);
	return $str;
    }

    function make_url()
    {
// ....... .    .
	$url = $this->scheme . '://';
	if ($this->user != '')
	    $url .= $this->user . ($this->pass != '' ? ':' . $this->pass : '');
	$url .= $this->host . $this->path;
	if ($this->query)
	    $url .= '?' . $this->query;
	if ($this->fragment)
	    $url .= '#' . $this->fragment;
	return $url;
    }
}

?>